/* main.c -- The main source for the web server.  This initializes the
 * connections.  Something seperate processes requests.
 *********************************************************************
 * By: Steve Conley, tanabi@bellsouth.net, sdconley@eos.ncsu.edu
 */

/* System includes */
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

/* Project includes */
#include "nettool/nettool.h"

/* Globals / #defines */
#define	PORT 8000		/* Default port               */
INPCON*	conhead;		/* Input connection structure */
char*	myname;

/* External functions */
void		process(CON* con);
extern	FILE* outp;

int	main(int argc,char** argv){
	int		port;
	CON*		ptr;
	struct	timeval pause;

/* We don't want to thrash the system too bad, so make a pause every loop
 * so other people can take some CPU time.
 */
	pause.tv_sec=0;
	pause.tv_usec=1000000;
	myname=(char*)malloc(100);
	bzero(myname,100);
	if(gethostname(myname,100) < 0){ /* Who am I? */
		perror("Couldn't gethostname");
		return (int) -1;
	}
/* Get our port and/or logfile name */
	if(argc > 1){
		if((conhead=inpcon_init(atoi(argv[1])))==NULL){
			fprintf(stderr,"inpcon_init failed, bailing out...\n");
			return (int) -1;
		}
		if(argc > 2){
			outp=fopen(argv[2],"w");
			if(!outp){
				fprintf(stderr,"Couldn't make file %s -- bailing out.\n",argv[2]);
				return (int) -1;
			}
		}
	}else{
		if((conhead=inpcon_init(PORT))==NULL){
			fprintf(stderr,"inpcon_init failed, bailing out...\n");
			return (int) -1;
		}
	}
/* conhead now has a valid connection in it.  Let's accept connections,
 * process, and go about our merry way.
 */
	while(1){
		if(inpcon_accept(conhead)){ /* Did we make any new connections? */
			process(conhead->head);
		}
		select(0,NULL,NULL,NULL,&pause); /* Sleep for a very little while */
	}
}
